summaryrefslogtreecommitdiffstats
path: root/zsh/oh-my-zsh/plugins/torrent
diff options
context:
space:
mode:
Diffstat (limited to 'zsh/oh-my-zsh/plugins/torrent')
-rw-r--r--zsh/oh-my-zsh/plugins/torrent/README.md13
-rw-r--r--zsh/oh-my-zsh/plugins/torrent/torrent.plugin.zsh17
2 files changed, 30 insertions, 0 deletions
diff --git a/zsh/oh-my-zsh/plugins/torrent/README.md b/zsh/oh-my-zsh/plugins/torrent/README.md
new file mode 100644
index 0000000..079aafc
--- /dev/null
+++ b/zsh/oh-my-zsh/plugins/torrent/README.md
@@ -0,0 +1,13 @@
+# torrent
+
+This plugin creates a Torrent file based on a [MagnetURI](https://en.wikipedia.org/wiki/Magnet_URI_scheme).
+
+To use it, add `torrent` to the plugins array in your zshrc file.
+
+```zsh
+plugins=(... torrent)
+```
+
+## Plugin commands
+
+* `magnet_to_torrent <MagnetURI>`: creates Torrent file.
diff --git a/zsh/oh-my-zsh/plugins/torrent/torrent.plugin.zsh b/zsh/oh-my-zsh/plugins/torrent/torrent.plugin.zsh
new file mode 100644
index 0000000..656e337
--- /dev/null
+++ b/zsh/oh-my-zsh/plugins/torrent/torrent.plugin.zsh
@@ -0,0 +1,17 @@
+#
+# Algorithm borrowed from http://wiki.rtorrent.org/MagnetUri and adapted to work with zsh.
+#
+
+function magnet_to_torrent() {
+ [[ "$1" =~ xt=urn:btih:([^\&/]+) ]] || return 1
+
+ hashh=${match[1]}
+
+ if [[ "$1" =~ dn=([^\&/]+) ]];then
+ filename=${match[1]}
+ else
+ filename=$hashh
+ fi
+
+ echo "d10:magnet-uri${#1}:${1}e" > "$filename.torrent"
+} \ No newline at end of file